<id>
TopicHover 4 YaBB231
</id>

<version>
0.5 beta
</version>

<mod info>
This mod will display the first 200 characters of a topic
when you hover a topic link on the Message Index page.

For YaBB 2.3.1

Instructions:

Apply the mod and upload (in ASCII mode):

cgi-bin/yabb2/Admin/ModList.pl
cgi-bin/yabb2/Sources/MessageIndex.pl
cgi-bin/yabb2/Sources/SubList.pl
cgi-bin/yabb2/Sources/System.pl
cgi-bin/yabb2/Languages/English/MessageIndex.lng
cgi-bin/yabb2/Templates/default/MessageIndex.template
cgi-bin/yabb2/Templates/yabb21/MessageIndex.template


From the topichover_4_yabb231_05 zip package upload:

In binary mode:
yabbfiles/ModImages/topichover/*.gif

</mod info>

<author>
Carsten
</author>

<edit file>
Admin/ModList.pl
</edit file>

<search for>
### END BOARDMOD ANCHOR ###
</search for>

<add before>
	$topichover_mod = "TopicHover_4_YaBB231|Carsten|This mod will display the first 200 characters of a topic when you hover a topic link on the Message Index page.|0.5 beta|02/20/09";
	push (@installed_mods, "$topichover_mod");

</add before>


<edit file>
Sources/MessageIndex.pl
</edit file>

<search for>
			if (${$mnum}{'board'} eq $annboard) {
				$msublink = qq~<a href="$scripturl?virboard=$currentboard;num=$mnum">$msub</a>~;
			} else {
				$msublink = qq~<a href="$scripturl?num=$mnum">$msub</a>~;
			}
</search for>

<replace>
			if(${$uid.$username}{'topicpreview'} || $iamguest) {
				fopen(MNUM, "$datadir/$mnum.txt");
				my $thetopic = <MNUM>;
				fclose(MNUM);
				my $themessage = (split /\|/, $thetopic)[8];
				$clip = 0;
				$msglength = 200;
				$testlength = 0;
				$pretextlength = 0;
				&FromHTML($themessage);
				$themessage =~ s~\[img\].*?\[\/img\]~[b][IMAGE][/b]~ig;
				$themessage =~ s~<br>~<br />~ig;
				$themessage =~ s~(<br />){2,}~<br />~ig;
				$themessage =~ s~^<br />~~ig;
	
				sub fixtags {
					($tmpmessage, $pretext, $pretag, $tagtext, $posttag) = @_;
					$testmessage = $tmpmessage;
					$testmessage =~ s~\[.*?\]~~g;
					$testmessage =~ s~\<.*?\>~~g;
					$testlength = length($testmessage);
					$pretextlength = length($pretext);
					$pretext =~ s~\[(.*?\])~|$1~g;
					$pretag =~ s~\[~|~;
					$tagtext =~ s~\[(.*?\])~|$1~g;
					$posttag =~ s~\[~|~;
	
					if($pretextlength > $msglength) {
						return $pretext;
					}
					if($testlength > $msglength) {
						$clip = 1;
						$lgtagtxtrem = ($msglength - $pretextlength) - 3;
						$tagtextrem = substr($tagtext, 0, $lgtagtxtrem);
						$msglength += (length($tmpmessage) - $testlength);
						return $pretext . $pretag . $tagtextrem . '...' . $posttag;
					}
					$msglength += (length($tmpmessage) - $testlength);
					return $pretext . $pretag . $tagtext . $posttag;
				}
	
				while ($testlength < $msglength && $themessage =~ s~^((.*?)(\[(\w+?)[\s|\=]*(.*?)\])(.*?)(\[\/\4\]))~ &fixtags($1,$2,$3,$6,$7) ~eisg) { }
				$themessage =~ s~\|(.*?\])~[$1~g;
				$themessage = substr($themessage, 0, $msglength);
				if(length($themessage) > ($msglength - 1) && !$clip) { $themessage .= "..."; }
				$message = $themessage;
				$displayname = ${$uid.$musername}{'realname'};
				&wrap;
				if ($enable_ubbc) {
					if (!$yyYaBBCloaded) { require "$sourcedir/YaBBC.pl"; }
					&DoUBBC;
				}
				&wrap2;
				$themessage = $message;
				$message = "";
				&ToChars($themessage);
				$themessage = &Censor($themessage);
				my $topicsum = qq~<div class="windowbg2" id="$mnum" style="position: absolute; top: 20px; left: 200px; width: 400px; border: 1px solid black; padding: 4px; z-index: 10000; overflow: hidden; display: none;">$themessage</div>~;
				if (${$mnum}{'board'} eq $annboard) {
					$msublink = qq~<a href="$scripturl?virboard=$currentboard;num=$mnum" onmouseover="topicSum(event, '$mnum')" onmouseout="topicSum(event, '$mnum')">$msub</a>$topicsum~;
				} else {
					$msublink = qq~<a href="$scripturl?num=$mnum" onmouseover="topicSum(event, '$mnum')" onmouseout="topicSum(event, '$mnum')">$msub</a>$topicsum~;
				}
			}
			else {
				if (${$mnum}{'board'} eq $annboard) {
					$msublink = qq~<a href="$scripturl?virboard=$currentboard;num=$mnum">$msub</a>~;
				} else {
					$msublink = qq~<a href="$scripturl?num=$mnum">$msub</a>~;
				}
			}
</replace>

<search for>
	$messageindex_template =~ s/({|<)yabb moderators(}|>)/$template_mods/g;
</search for>

<add after>
	if (!$iamguest) {
		if(${$uid.$username}{'topicpreview'}) {
			$enab_topicprev = qq~<a href="$scripturl?board=$INFO{'board'};start=$start;action=topicpreview;todo=disable"><img src="$modimgurl/topichover/tpoff.gif" border="0" alt="$messageindex_tp{'disabletp'}" title="$messageindex_tp{'disabletp'}" style="vertical-align: middle;" /><br /></a>~;
		}
		else {
			$enab_topicprev = qq~<a href="$scripturl?board=$INFO{'board'};start=$start;action=topicpreview;todo=enable"><img src="$modimgurl/topichover/tpon.gif" border="0" alt="$messageindex_tp{'enabletp'}" title="$messageindex_tp{'enabletp'}" style="vertical-align: middle;" /><br /></a>~;
		}
	}
	else {
			$enab_topicprev = "";
	}
	$messageindex_template =~ s/({|<)yabb topicpreview(}|>)/$enab_topicprev/g;
</add after>

<search for>
	$yymain .= qq~
	$messageindex_template
	$pageindexjs
</search for>

<add after>
	<script language="JavaScript1.2" type="text/javascript">
	<!--

	function topicSum(e, topicsumm) {
		if (document.getElementById(topicsumm).style.display == 'inline') {
			document.getElementById(topicsumm).style.height = '';
			document.getElementById(topicsumm).style.display = 'none';
		}
		else {
			document.getElementById(topicsumm).style.display = 'inline';
			var dheight = document.getElementById(topicsumm).offsetHeight;
			var dtop = document.all ? e.clientY + document.documentElement.scrollTop - (dheight + 30) : e.pageY - (dheight + 30);
			document.getElementById(topicsumm).style.top = dtop + 'px';
			document.getElementById(topicsumm).style.height = dheight + 'px';
		}
	}

	-->
	</script>
</add after>

<search for>
1;
</search for>

<add before>
sub SetTopicPreview {
	if ($INFO{'todo'} eq "disable") {
		${$uid.$username}{'topicpreview'} = "0";
	}
	else {
		${$uid.$username}{'topicpreview'} = "1";
	}
	&UserAccount($username, "update");
	&redirectinternal;
}

</add before>

<edit file>
Sources/SubList.pl
</edit file>

<search for>
'threadpagetext',"Display.pl&ThreadPageindex",
</search for>

<add after>
'topicpreview',"MessageIndex.pl&SetTopicPreview",
</add after>


<edit file>
Sources/System.pl
</edit file>

<search for>
	my @tags = qw(password realname email regdate regreason webtitle weburl spamcount spamtime signature postcount position addgroups icq aim yim skype gender usertext userpic regtime location bday timeselect timeoffset timeformat hidemail msn gtalk template language lastonline lastpost lastim im_ignorelist im_popup im_imspop notify_me board_notifications thread_notifications cathide postlayout session sesquest sesanswer favorites dsttimeoffset pageindex lastips onlinealert pmactprev pmmessprev pmviewMess buddylist offlinestatus awaysubj awayreply awayreplysent stealth reversetopic);
</search for>

<add after>
	push(@tags, "topicpreview");
</add after>


<edit file>
Languages/English/MessageIndex.lng
</edit file>

<search for>
1;
</search for>

<add before>
%messageindex_tp = (
'enabletp' => 'Enable Topic Preview',
'disabletp' => 'Disable Topic Preview',
);

</add before>


<edit file>
Templates/default/MessageIndex.template
</edit file>

<search for>
	<td class="titlebg" width="32%" align="left">
		$messageindex_txt{'70'}
	</td>
</search for>

<replace>
	<td class="titlebg" width="32%" align="left">
		$messageindex_txt{'70'} {yabb topicpreview}
	</td>
</replace>


<edit file>
Templates/yabb21/MessageIndex.template
</edit file>

<search for>
<table cellpadding="4" cellspacing="1" border="0" width="100%" class="bordercolor">
<tr>
	<td class="titlebg" width="10%" colspan="2" align="center">
		<yabb rss>
	</td>
	<td class="titlebg" width="48%" align="left">
		$messageindex_txt{'70'}
	</td>
</search for>

<replace>
<table cellpadding="4" cellspacing="1" border="0" width="100%" class="bordercolor">
<tr>
	<td class="titlebg" width="10%" colspan="2" align="center">
		<yabb rss>
	</td>
	<td class="titlebg" width="48%" align="left">
		$messageindex_txt{'70'} <yabb topicpreview>
	</td>
</replace>
